#include "exportdialog.h"
#include "ui_exportdialog.h"

exportdialog::exportdialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::exportdialog)
{
    ui->setupUi(this);
    data = NULL;
    setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowCloseButtonHint);
}

exportdialog::~exportdialog()
{
    delete ui;
}

/**Closes the export dialog.*/
void exportdialog::on_cancel_button_clicked()
{
    this->close();
}

/**Sets beginning and end to user selection.*/
int exportdialog::setData(tdata *dat, int b, int e)
{
    beginning = b;
    end = e;
    data = dat;
    return 0;
}

/**Exports the data with the given options.*/
void exportdialog::on_export_button_clicked()
{
    //select directory
    QFileDialog *file_dialog = new QFileDialog;
    file_dialog->setWindowIcon(QIcon(":/images/icon.png"));
    file_dialog->setOption(QFileDialog::ShowDirsOnly,true);
    QString folder = file_dialog->getExistingDirectory(this, tr("Select directory for export"));
    delete file_dialog;

    if(!folder.isEmpty())
    {
        //export to directory with selected options
        if(ui->radio_alldata->isChecked())
            data->exportToFile(ui->radio_csv->isChecked(), ui->check_pictures->isChecked(), 0, data->length, folder);
        else
            data->exportToFile(ui->radio_csv->isChecked(), ui->check_pictures->isChecked(), beginning, end, folder);

        //close dialog
        this->close();
    }
}
