#include "mainwindow.h"
#include "ui_mainwindow.h"

//####SET CURVE COLORS####

//PLOTTER0
/**Is called on changing the altitude curve's color.*/
void MainWindow::on_comboAltitudeColor_currentIndexChanged(int index)
{
    plotter[0]->setColor(index,2);
}

//PLOTTER1
/**Is called on changing the speed curve's color.*/
void MainWindow::on_comboXSpeedColor_currentIndexChanged(int index)
{
    plotter[1]->setColor(index,0);
}

/**Is called on changing the course curve's color.*/
void MainWindow::on_comboYSpeedColor_currentIndexChanged(int index)
{
    plotter[1]->setColor(index,1);
}

//PLOTTER2

/**Is called on changing the x acceleration curve's color.*/
void MainWindow::on_comboXAccColor_currentIndexChanged(int index)
{
    plotter[2]->setColor(index,0);
}

/**Is called on changing the y acceleration curve's color.*/
void MainWindow::on_comboYAccColor_currentIndexChanged(int index)
{
    plotter[2]->setColor(index,1);
}

/**Is called on changing the z acceleration curve's color.*/
void MainWindow::on_comboZAccColor_currentIndexChanged(int index)
{
    plotter[2]->setColor(index,2);
}

//PLOTTER3

/**Is called on changing the x angular acceleration curve's color.*/
void MainWindow::on_comboXAngAccColor_currentIndexChanged(int index)
{
    plotter[3]->setColor(index,0);
}

/**Is called on changing the y angular acceleration curve's color.*/
void MainWindow::on_comboYAngAccColor_currentIndexChanged(int index)
{
    plotter[3]->setColor(index,1);
}

/**Is called on changing the z angular acceleration curve's color.*/
void MainWindow::on_comboZAngAccColor_currentIndexChanged(int index)
{
    plotter[3]->setColor(index,2);
}

//PLOTTER4

/**Is called on changing the obd curve's color.*/
void MainWindow::on_comboOBDColor_currentIndexChanged(int index)
{
    for(int i = 0; i<8; i++)
        plotter[4]->setColor(index,i);
}

//####SET CURVE THICKNESSES####

//PLOTTER0

/**Is called on changing the altitude curve's thickness.*/
void MainWindow::on_comboAltitudeThickness_currentIndexChanged(int index)
{
    plotter[0]->setThickness(index,2);
}

//PLOTTER1

/**Is called on changing the speed curve's thickness.*/
void MainWindow::on_comboXSpeedThickness_currentIndexChanged(int index)
{
    plotter[1]->setThickness(index,0);
}

/**Is called on changing the course curve's thickness.*/
void MainWindow::on_comboYSpeedThickness_currentIndexChanged(int index)
{
    plotter[1]->setThickness(index,1);
}

//PLOTTER2

/**Is called on changing the x acceleration curve's thickness.*/
void MainWindow::on_comboXAccThickness_currentIndexChanged(int index)
{
    plotter[2]->setThickness(index,0);
}

/**Is called on changing the y acceleration curve's thickness.*/
void MainWindow::on_comboYAccThickness_currentIndexChanged(int index)
{
    plotter[2]->setThickness(index,1);
}

/**Is called on changing the z acceleration curve's thickness.*/
void MainWindow::on_comboZAccThickness_currentIndexChanged(int index)
{
    plotter[2]->setThickness(index,2);
}

//PLOTTER3

/**Is called on changing the x angular acceleration curve's thickness.*/
void MainWindow::on_comboXAngAccThickness_currentIndexChanged(int index)
{
    plotter[3]->setThickness(index,0);
}

/**Is called on changing the y angular acceleration curve's thickness.*/
void MainWindow::on_comboYAngAccThickness_currentIndexChanged(int index)
{
    plotter[3]->setThickness(index,1);
}

/**Is called on changing the z angular acceleration curve's thickness.*/
void MainWindow::on_comboZAngAccThickness_currentIndexChanged(int index)
{
    plotter[3]->setThickness(index,2);
}

//PLOTTER4

/**Is called on changing the obd curve's thickness.*/
void MainWindow::on_comboOBDThickness_currentIndexChanged(int index)
{
    for(int i = 0; i<8; i++)
        plotter[4]->setThickness(index,i);
}

//####HIDE/UNHIDE CURVES####

//PLOTTER0

/**Is called on hiding/unhiding the altitude curve.*/
void MainWindow::on_checkAltitude_toggled(bool checked)
{
    plotter[0]->setVisible(checked,2);
}

//PLOTTER1

/**Is called on hiding/unhiding the speed curve.*/
void MainWindow::on_checkXSpeed_toggled(bool checked)
{
    plotter[1]->setVisible(checked,0);
}

/**Is called on hiding/unhiding the course curve.*/
void MainWindow::on_checkYSpeed_toggled(bool checked)
{
    plotter[1]->setVisible(checked,1);
}

//PLOTTER2

/**Is called on hiding/unhiding the x acceleration curve.*/
void MainWindow::on_checkXAcc_toggled(bool checked)
{
    plotter[2]->setVisible(checked,0);
}

/**Is called on hiding/unhiding the y acceleration curve.*/
void MainWindow::on_checkYAcc_toggled(bool checked)
{
    plotter[2]->setVisible(checked,1);
}

/**Is called on hiding/unhiding the z acceleration curve.*/
void MainWindow::on_checkZAcc_toggled(bool checked)
{
    plotter[2]->setVisible(checked,2);
}

//PLOTTER3

/**Is called on hiding/unhiding the x angular acceleration curve.*/
void MainWindow::on_checkXAngAcc_toggled(bool checked)
{
    plotter[3]->setVisible(checked,0);
}

/**Is called on hiding/unhiding the y angular acceleration curve.*/
void MainWindow::on_checkYAngAcc_toggled(bool checked)
{
    plotter[3]->setVisible(checked,1);
}

/**Is called on hiding/unhiding the z angular acceleration curve.*/
void MainWindow::on_checkZAngAcc_toggled(bool checked)
{
    plotter[3]->setVisible(checked,2);
}

//####RESET ZOOM####

/**Is called on resetting the zoom.*/
void MainWindow::on_CoordResetButton_clicked()
{
    //reset zoom
    for(int i = 0; i<5; i++)
    {
        plotter[i]->resetZoom();
    }

    //reset route
    gpsmap->setRoute(exp->data->longitude,exp->data->latitude,
                     ui->spinCoordBegin->value(),ui->spinCoordEnd->value()+1);
}

//####SET SPINBOXES####
//PLOTTER0

/**Is called on changing the begin spinbox.*/
void MainWindow::on_spinCoordBegin_valueChanged(int arg1)
{
    //rescale plotters accordingly
    for(int i = 0; i<5; i++)
    {
        plotter[i]->rescale(arg1, ui->spinCoordEnd->value());
    }

    //reset route and car
    gpsmap->setRoute(exp->data->longitude,exp->data->latitude,
                     ui->spinCoordBegin->value(),ui->spinCoordEnd->value()+1);
    gpsmap->removeCar();

    //set min/max for the spinboxes
    ui->spinCoordEnd->setMinimum(ui->spinCoordBegin->value()+1);
    ui->spinCoordBegin->setMaximum(ui->spinCoordEnd->value()-1);
    this->updateView();
}

/**Is called on changing the end spinbox.*/
void MainWindow::on_spinCoordEnd_valueChanged(int arg1)
{
    //rescale plotters accordingly
    for(int i = 0; i<5; i++)
    {
        plotter[i]->rescale(ui->spinCoordBegin->value(), arg1);
    }

    //reset route and car
    gpsmap->setRoute(exp->data->longitude,exp->data->latitude,
                     ui->spinCoordBegin->value(),ui->spinCoordEnd->value()+1);
    gpsmap->removeCar();

    //set min/max for the spinboxes
    ui->spinCoordEnd->setMinimum(ui->spinCoordBegin->value()+1);
    ui->spinCoordBegin->setMaximum(ui->spinCoordEnd->value()-1);
    this->updateView();
}

/**Adjusts thumbnail view to the actual begin and end spinbox values. */
void MainWindow::updateView()
{
    //return when no pictures were found in DCIM folder
    if(thumbviewer->fileList.isEmpty())
        return;

    QString pic = thumbviewer->fileList.at(0);
    pic.truncate(pic.length()-4);
    pic.remove(0,pic.length()-15);
    int begin = 0;
    int end = thumbviewer->fileList.count()-1;
    //find the first picture that was taken in the chosen interval
    while(QDateTime::fromString(pic,"yyyyMMdd_hhmmss")<=
          QDateTime::fromString(exp->data->utc->at(ui->spinCoordBegin->value()),"yyyy-MM-dd hh:mm:ss:zzz")&& begin < thumbviewer->fileList.count()-1)
    {
        begin++;
        pic = thumbviewer->fileList.at(begin);
        pic.truncate(pic.length()-4);
        pic.remove(0,pic.length()-15);
    }

    pic = thumbviewer->fileList.at(end);
    pic.truncate(pic.length()-4);
    pic.remove(0,pic.length()-15);
    //find the last picture that was taken in the chosen interval
    while(QDateTime::fromString(pic,"yyyyMMdd_hhmmss")>
          QDateTime::fromString(exp->data->utc->at(ui->spinCoordEnd->value()),"yyyy-MM-dd hh:mm:ss:zzz"))
    {
        end--;
        pic = thumbviewer->fileList.at(end);
        pic.truncate(pic.length()-4);
        pic.remove(0,pic.length()-15);
    }

    thumbviewer->view->setSceneRect(-2+(begin-1)*75,0,(end-begin+2)*75-16,100);
}

//####SET OBD DISPLAY####
/**Is called when the user changes the displayed obd curve.*/
void MainWindow::on_comboOBDValue_currentIndexChanged(int index)
{
    //unhide specified curve
    for(int i = 0; i<8; i++)
    {
        if(i == index)
            plotter[4]->setVisible(true,i);
        else
            plotter[4]->setVisible(false,i);
    }

    //set title
    switch(index)
    {
        case 0:
        plotter[4]->setYaxisTitle(tr("Speed [km/h]"));
        break;

        case 1:
        plotter[4]->setYaxisTitle(tr("Throttle position [%]"));
        break;

        case 2:
        plotter[4]->setYaxisTitle(tr("Engine RPM [rpm]"));
        break;

        case 3:
        plotter[4]->setYaxisTitle(tr("Actual engine - percent torque [%]"));
        break;

        case 4:
        plotter[4]->setYaxisTitle(tr("Engine reference torque [Nm]"));
        break;

        case 5:
        plotter[4]->setYaxisTitle(tr("Intake air temperature [C]"));
        break;

        case 6:
        plotter[4]->setYaxisTitle(tr("Ambient air temperature [C]"));
        break;

        case 7:
        plotter[4]->setYaxisTitle(tr("Barometric pressure [kPa]"));
        break;
    }

    //refresh all other axis' for translation
    plotter[0]->setYaxisTitle(tr("Altitude [m]"));
    plotter[0]->setCurveTitle(tr("Altitude"),2);
    plotter[0]->setXaxisTitle(tr("Universal Time Coordinated [h:m:s:ms]"));
    plotter[1]->setYaxisTitle(tr("Speed [m/s]"));
    plotter[1]->setCurveTitle(tr("Speed"),0);
    plotter[1]->setCurveTitle(tr("Course"),1);
    plotter[1]->setAxis(tr("Course [degree]"),1);
    plotter[1]->setXaxisTitle(tr("Universal Time Coordinated [h:m:s:ms]"));
    plotter[2]->setYaxisTitle(tr("Acceleration [g]"));
    plotter[2]->setCurveTitle(tr("X-Direction"),0);
    plotter[2]->setCurveTitle(tr("Y-Direction"),1);
    plotter[2]->setCurveTitle(tr("Z-Direction"),2);
    plotter[2]->setXaxisTitle(tr("Universal Time Coordinated [h:m:s:ms]"));
    plotter[3]->setYaxisTitle(tr("Angular Acceleration [rad/s]"));
    plotter[3]->setCurveTitle(tr("X-Axis"),0);
    plotter[3]->setCurveTitle(tr("Y-Axis"),1);
    plotter[3]->setCurveTitle(tr("Z-Axis"),2);
    plotter[3]->setXaxisTitle(tr("Universal Time Coordinated [h:m:s:ms]"));
    plotter[4]->setCurveTitle(tr("Speed"),0);
    plotter[4]->setCurveTitle(tr("Throttle position"),1);
    plotter[4]->setCurveTitle(tr("Engine RPM"),2);
    plotter[4]->setCurveTitle(tr("Actual engine - percent torque"),3);
    plotter[4]->setCurveTitle(tr("Engine reference torque"),4);
    plotter[4]->setCurveTitle(tr("Intake air temperature"),5);
    plotter[4]->setCurveTitle(tr("Ambient air temperature"),6);
    plotter[4]->setCurveTitle(tr("Barometric pressure"),7);
    plotter[4]->setXaxisTitle(tr("Universal Time Coordinated [h:m:s:ms]"));
}

/**Reset the view.*/
void MainWindow::on_pushButton_2_clicked()
{
    //reset zoom
    for(int i = 0; i<5; i++)
    {
        plotter[i]->resetZoom();
    }

    //reset the route
    gpsmap->setRoute(exp->data->longitude,exp->data->latitude,
                     ui->spinCoordBegin->value(),ui->spinCoordEnd->value()+1);

    //reset spinbox values
    ui->spinCoordBegin->setValue(0);
    ui->spinCoordEnd->setValue(exp->data->length);
}
