/*Copyright (C) 2012 Johannes Hiller, Michael Hoppe, Waldemar Heinrich
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*       http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*/
package de.tui.itlogger;

import android.hardware.SensorEvent;


/**
 *Class for implementing the sensors
 * @see GPS
 */
public class Sensoren extends iTloggerActivity {
	static int[] values_a = new int[3];
	static int[] values_g = new int[3];
	static boolean rotate=false;
	static byte x=0, y=1, z=2;

	static int MultDecimal(double value, int decimalPlace) {
        int help=0;
        help = (int) (value*Math.pow(10, decimalPlace)); 
        return help;
	}

	/**
	 * Gets the values from the gyroscope
	 * @param event the event of the sensor 
	 */
	static void getGyroscope(SensorEvent event) {	
		values_g[0]=MultDecimal(event.values[x], 2);
		values_g[1]=MultDecimal(event.values[y], 2);
		values_g[2]=MultDecimal(event.values[z], 2);	
		}
	/**
	 * Gets and calibrates the values from the Acclerometer
	 * @param event a SensorEvent
	 */
	static void getAccelerometer(SensorEvent event) {
		//correction of the acceleration values normal direction

		if (rotate==false){
			values_a[2]=-MultDecimal(event.values[z]/9.80665, 2);
				if (z==2){
					values_a[1]=-MultDecimal(event.values[y]/9.80665,2);
				
				}
		else{
				values_a[1]=MultDecimal(event.values[y]/9.80665,2);	
			}
			if((z==1)||(z==2)){
				values_a[0]=-MultDecimal(event.values[x]/9.80665,2);	
				}else{
						values_a[0]=MultDecimal(event.values[x]/9.80665,2);	
						}
		}
		//upside down
		else{
		values_a[2]=MultDecimal(event.values[z]/9.80665,2);
			values_a[1]=MultDecimal(event.values[y]/9.80665,2);
			
			if((z==2) || (z==0)){
				values_a[0]=-MultDecimal(event.values[x]/9.80665,2);	
				}else{
					values_a[0]=MultDecimal(event.values[x]/9.80665,2);	
					}
		}
		//calibrate the sensors
		if(iTloggerActivity.calibrate==true){	
			byte help_1=-1, help_2=-1;
			values_a[0]=MultDecimal(event.values[0]/9.80665,2);
			values_a[1]=MultDecimal(event.values[1]/9.80665,2);
			values_a[2]=MultDecimal(event.values[2]/9.80665,2);
		
			//get position right now
			for(byte i=0; i<3 ;i++)
			{
				if((values_a[i]>70)||(values_a[i]<-70)){
	    	  
					if(values_a[i]<-70){
						rotate=true;
					}else{
						rotate=false;
					} 
					//align the axis
					z=i;  	  
					for(byte i_help=0; i_help<3;i_help++){
							if(i_help != i){
								if(help_1>-1){
									help_2=i_help;
									}else{
										help_1=i_help;
									}
							}
					}
					x=help_1;
					y=help_2;   		
				}     
	    		}  
			iTloggerActivity.calibrate=false;
		}
	}
}
